/// <reference types="node" />
import { StartDevServerOptions as RsbuildStartDevServerOptions, StartServerResult, RsbuildInstance, DevConfig, ServerConfig } from '@rsbuild/shared';
import type { ModernDevServerOptions } from '@modern-js/server';
import type { Server } from 'node:http';
import { type InitProdMiddlewares } from '@modern-js/prod-server';
import type { UniBuilderConfig, ToolsDevServerConfig } from '../types';
type ServerOptions = Partial<Omit<ModernDevServerOptions, 'config'>> & {
    config?: Partial<ModernDevServerOptions['config']>;
};
export declare const transformToRsbuildServerOptions: (dev: NonNullable<UniBuilderConfig['dev']>, devServer: ToolsDevServerConfig) => {
    dev: DevConfig;
    server: ServerConfig;
};
export type StartDevServerOptions = RsbuildStartDevServerOptions & {
    apiOnly?: boolean;
    serverOptions?: ServerOptions;
    initProdMiddlewares?: InitProdMiddlewares;
};
export type UniBuilderStartServerResult = Omit<StartServerResult, 'server'> & {
    server: Server;
};
export declare function startDevServer(rsbuild: RsbuildInstance, options: StartDevServerOptions | undefined, builderConfig: UniBuilderConfig): Promise<UniBuilderStartServerResult>;
export {};
