"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var devServer_exports = {};
__export(devServer_exports, {
  startDevServer: () => startDevServer,
  transformToRsbuildServerOptions: () => transformToRsbuildServerOptions
});
module.exports = __toCommonJS(devServer_exports);
var import_shared = require("@rsbuild/shared");
var import_prod_server = require("@modern-js/prod-server");
const getServerOptions = (builderConfig) => {
  var _builderConfig_output_distPath, _builderConfig_output, _builderConfig_output1, _builderConfig_output2;
  return {
    output: {
      path: (_builderConfig_output = builderConfig.output) === null || _builderConfig_output === void 0 ? void 0 : (_builderConfig_output_distPath = _builderConfig_output.distPath) === null || _builderConfig_output_distPath === void 0 ? void 0 : _builderConfig_output_distPath.root,
      assetPrefix: (_builderConfig_output1 = builderConfig.output) === null || _builderConfig_output1 === void 0 ? void 0 : _builderConfig_output1.assetPrefix,
      distPath: (_builderConfig_output2 = builderConfig.output) === null || _builderConfig_output2 === void 0 ? void 0 : _builderConfig_output2.distPath
    },
    source: {
      alias: {}
    },
    html: {},
    tools: {
      babel: {}
    },
    server: {},
    runtime: {},
    bff: {}
  };
};
const transformToRsbuildServerOptions = (dev, devServer) => {
  var _newDevServerConfig_devMiddleware, _newDevServerConfig_before, _newDevServerConfig_after;
  const { port = 8080, host, https, ...devConfig } = dev;
  var _dev_hmr;
  const newDevServerConfig = (0, import_shared.mergeChainedOptions)({
    defaults: {
      devMiddleware: {
        writeToDisk: (file) => !file.includes(".hot-update.")
      },
      hot: (_dev_hmr = dev === null || dev === void 0 ? void 0 : dev.hmr) !== null && _dev_hmr !== void 0 ? _dev_hmr : true,
      liveReload: true,
      client: {
        path: "/webpack-hmr",
        overlay: false,
        ...devConfig.client || {}
      }
    },
    options: devServer,
    mergeFn: import_shared.deepmerge
  });
  const rsbuildDev = {
    ...devConfig,
    writeToDisk: (_newDevServerConfig_devMiddleware = newDevServerConfig.devMiddleware) === null || _newDevServerConfig_devMiddleware === void 0 ? void 0 : _newDevServerConfig_devMiddleware.writeToDisk,
    hmr: newDevServerConfig.hot,
    client: newDevServerConfig.client,
    liveReload: newDevServerConfig.liveReload
  };
  if (dev.progressBar === void 0) {
    rsbuildDev.progressBar = true;
  }
  if (((_newDevServerConfig_before = newDevServerConfig.before) === null || _newDevServerConfig_before === void 0 ? void 0 : _newDevServerConfig_before.length) || ((_newDevServerConfig_after = newDevServerConfig.after) === null || _newDevServerConfig_after === void 0 ? void 0 : _newDevServerConfig_after.length)) {
    rsbuildDev.setupMiddlewares = [
      ...newDevServerConfig.setupMiddlewares || [],
      (middlewares) => {
        middlewares.unshift(...newDevServerConfig.before || []);
        middlewares.push(...newDevServerConfig.after || []);
      }
    ];
  } else if (newDevServerConfig.setupMiddlewares) {
    rsbuildDev.setupMiddlewares = newDevServerConfig.setupMiddlewares;
  }
  const server = (0, import_shared.isProd)() ? {
    publicDir: false,
    htmlFallback: false,
    printUrls: false
  } : {
    publicDir: false,
    htmlFallback: false,
    printUrls: false,
    compress: newDevServerConfig.compress,
    headers: newDevServerConfig.headers,
    historyApiFallback: newDevServerConfig.historyApiFallback,
    proxy: newDevServerConfig.proxy,
    port,
    host,
    https: https ? https : void 0
  };
  return {
    dev: rsbuildDev,
    server
  };
};
const getDevServerOptions = async ({ builderConfig, serverOptions }) => {
  const defaultConfig = getServerOptions(builderConfig);
  const config = serverOptions.config ? (0, import_shared.deepmerge)(defaultConfig, serverOptions.config) : defaultConfig;
  return {
    config
  };
};
async function startDevServer(rsbuild, options = {}, builderConfig) {
  var _serverOptions_dev, _serverOptions_dev1;
  (0, import_shared.debug)("create dev server");
  if (!options.initProdMiddlewares) {
    options.initProdMiddlewares = import_prod_server.initProdMiddlewares;
  }
  const { createDevServer } = await Promise.resolve().then(() => __toESM(require("@modern-js/server")));
  const rsbuildServer = await rsbuild.createDevServer({
    ...options,
    runCompile: !options.apiOnly
  });
  const { serverOptions = {} } = options;
  const { config } = await getDevServerOptions({
    builderConfig,
    serverOptions
  });
  const rsbuildConfig = rsbuild.getNormalizedConfig();
  var _serverOptions_dev_https;
  const https = (_serverOptions_dev_https = (_serverOptions_dev = serverOptions.dev) === null || _serverOptions_dev === void 0 ? void 0 : _serverOptions_dev.https) !== null && _serverOptions_dev_https !== void 0 ? _serverOptions_dev_https : rsbuildConfig.server.https;
  const { port } = rsbuildServer;
  const { server: { host }, dev: { writeToDisk } } = rsbuildConfig;
  var _serverOptions_dev_watch;
  const server = await createDevServer({
    pwd: rsbuild.context.rootPath,
    ...serverOptions,
    appContext: serverOptions.appContext || {},
    rsbuild,
    getMiddlewares: () => ({
      middlewares: rsbuildServer.middlewares,
      close: rsbuildServer.close,
      onHTTPUpgrade: rsbuildServer.onHTTPUpgrade
    }),
    dev: {
      watch: (_serverOptions_dev_watch = (_serverOptions_dev1 = serverOptions.dev) === null || _serverOptions_dev1 === void 0 ? void 0 : _serverOptions_dev1.watch) !== null && _serverOptions_dev_watch !== void 0 ? _serverOptions_dev_watch : true,
      https,
      writeToDisk
    },
    config
  }, options.initProdMiddlewares);
  const protocol = https ? "https" : "http";
  const urls = (0, import_shared.getAddressUrls)({
    protocol,
    port,
    host
  });
  (0, import_shared.debug)("listen dev server");
  return new Promise((resolve) => {
    server.listen({
      host,
      port
    }, async (err) => {
      if (err) {
        throw err;
      }
      (0, import_shared.debug)("listen dev server done");
      await rsbuildServer.afterListen();
      resolve({
        port,
        urls: urls.map((item) => item.url),
        server
      });
    });
  });
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  startDevServer,
  transformToRsbuildServerOptions
});
