"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var parseCommonConfig_exports = {};
__export(parseCommonConfig_exports, {
  isLooseCssModules: () => isLooseCssModules,
  parseCommonConfig: () => parseCommonConfig
});
module.exports = __toCommonJS(parseCommonConfig_exports);
var import_shared = require("@rsbuild/shared");
var import_core = require("@rsbuild/core");
var import_plugin_toml = require("@rsbuild/plugin-toml");
var import_plugin_yaml = require("@rsbuild/plugin-yaml");
var import_plugin_react = require("@rsbuild/plugin-react");
var import_globalVars = require("./plugins/globalVars");
var import_runtimeChunk = require("./plugins/runtimeChunk");
var import_frameworkConfig = require("./plugins/frameworkConfig");
var import_splitChunk = require("./plugins/splitChunk");
var import_plugin_css_minimizer = require("@rsbuild/plugin-css-minimizer");
var import_postcssLegacy = require("./plugins/postcssLegacy");
var import_devtools = require("./plugins/devtools");
var import_emitRouteFile = require("./plugins/emitRouteFile");
var import_antd = require("./plugins/antd");
var import_arco = require("./plugins/arco");
var import_devServer = require("./devServer");
const GLOBAL_CSS_REGEX = /\.global\.\w+$/;
const isLooseCssModules = (path) => {
  if (import_shared.NODE_MODULES_REGEX.test(path)) {
    return import_shared.CSS_MODULES_REGEX.test(path);
  }
  return !GLOBAL_CSS_REGEX.test(path);
};
function removeUndefinedKey(obj) {
  Object.keys(obj).forEach((key) => {
    if (obj[key] === void 0) {
      delete obj[key];
    }
  });
  return obj;
}
const DEFAULT_WEB_BROWSERSLIST = [
  "> 0.01%",
  "not dead",
  "not op_mini all"
];
const DEFAULT_BROWSERSLIST = {
  web: DEFAULT_WEB_BROWSERSLIST,
  node: [
    "node >= 14"
  ],
  "web-worker": DEFAULT_WEB_BROWSERSLIST,
  "service-worker": DEFAULT_WEB_BROWSERSLIST
};
async function getBrowserslistWithDefault(path, config, target) {
  const { overrideBrowserslist: overrides = {} } = (config === null || config === void 0 ? void 0 : config.output) || {};
  if (target === "web" || target === "web-worker") {
    if (Array.isArray(overrides)) {
      return overrides;
    }
    if (overrides[target]) {
      return overrides[target];
    }
    const browserslistrc = await (0, import_shared.getBrowserslist)(path);
    if (browserslistrc) {
      return browserslistrc;
    }
  }
  if (!Array.isArray(overrides) && overrides[target]) {
    return overrides[target];
  }
  return DEFAULT_BROWSERSLIST[target];
}
const isUseCssSourceMap = (disableSourceMap = {}) => {
  if (typeof disableSourceMap === "boolean") {
    return !disableSourceMap;
  }
  if (disableSourceMap.css === void 0) {
    return process.env.NODE_ENV !== "production";
  }
  return !disableSourceMap.css;
};
async function parseCommonConfig(uniBuilderConfig, options) {
  var _uniBuilderConfig_output, _uniBuilderConfig_tools;
  var _output, _output_distPath, _output_distPath1, _output1, _extraConfig, _html, _extraConfig1;
  const { cwd, frameworkConfigPath, entry, target } = options;
  const { plugins: [...plugins] = [], performance: { ...performanceConfig } = {}, output: { disableFilenameHash, enableLatestDecorators, cssModuleLocalIdentName, enableInlineScripts, disableCssExtract, enableInlineStyles, disableCssModuleExtension, disableTsChecker, disableSvgr, svgDefaultExport, assetsRetry, enableAssetFallback, enableAssetManifest, disableSourceMap, convertToRem, disableMinimize, polyfill, ...outputConfig } = {}, html: { disableHtmlFolder, metaByEntries, titleByEntries, faviconByEntries, injectByEntries, templateByEntries, templateParametersByEntries, tagsByEntries, tags, ...htmlConfig } = {}, source: { alias, globalVars, resolveMainFields, resolveExtensionPrefix, ...sourceConfig } = {}, dev, security: { checkSyntax, sri, ...securityConfig } = {}, tools: { devServer, tsChecker, minifyCss, ...toolsConfig } = {} } = uniBuilderConfig;
  const rsbuildConfig = {
    plugins,
    output: {
      polyfill: polyfill === "ua" ? "off" : polyfill,
      ...outputConfig
    },
    source: {
      alias,
      ...sourceConfig
    },
    performance: performanceConfig,
    html: htmlConfig,
    tools: toolsConfig,
    security: securityConfig
  };
  const { html = {}, output = {}, source = {} } = rsbuildConfig;
  if (enableLatestDecorators) {
    source.decorators = {
      version: "2022-03"
    };
  }
  if (disableMinimize) {
    var _output2;
    (_output2 = output).minify || (_output2.minify = false);
  }
  if (cssModuleLocalIdentName) {
    var _output3;
    (_output3 = output).cssModules || (_output3.cssModules = {});
    output.cssModules.localIdentName = cssModuleLocalIdentName;
  }
  if (isUseCssSourceMap(disableSourceMap)) {
    var _output4;
    (_output4 = output).sourceMap || (_output4.sourceMap = {});
    output.sourceMap.css = true;
  }
  var _distPath;
  (_distPath = (_output = output).distPath) !== null && _distPath !== void 0 ? _distPath : _output.distPath = {};
  var _html1;
  (_html1 = (_output_distPath = output.distPath).html) !== null && _html1 !== void 0 ? _html1 : _output_distPath.html = "html";
  var _server;
  (_server = (_output_distPath1 = output.distPath).server) !== null && _server !== void 0 ? _server : _output_distPath1.server = "bundles";
  var _polyfill;
  (_polyfill = (_output1 = output).polyfill) !== null && _polyfill !== void 0 ? _polyfill : _output1.polyfill = "entry";
  if (disableCssModuleExtension) {
    var _output5, _output_cssModules;
    (_output5 = output).cssModules || (_output5.cssModules = {});
    var _auto;
    (_auto = (_output_cssModules = output.cssModules).auto) !== null && _auto !== void 0 ? _auto : _output_cssModules.auto = isLooseCssModules;
  }
  if (enableInlineScripts) {
    output.inlineScripts = enableInlineScripts;
  }
  if (disableCssExtract) {
    output.injectStyles = disableCssExtract;
  }
  const targets = Array.isArray(target) ? target : [
    target || "web"
  ];
  output.targets = targets;
  const overrideBrowserslist = {};
  for (const target2 of targets) {
    overrideBrowserslist[target2] = await getBrowserslistWithDefault(cwd, uniBuilderConfig, target2);
  }
  output.overrideBrowserslist = overrideBrowserslist;
  if (enableInlineStyles) {
    output.inlineStyles = enableInlineStyles;
  }
  if (disableFilenameHash !== void 0) {
    output.filenameHash = !disableFilenameHash;
  }
  const extraConfig = {};
  (_extraConfig = extraConfig).html || (_extraConfig.html = {});
  extraConfig.html.outputStructure = disableHtmlFolder ? "flat" : "nested";
  if (metaByEntries) {
    extraConfig.html.meta = ({ entryName }) => metaByEntries[entryName];
  }
  var _title;
  (_title = (_html = html).title) !== null && _title !== void 0 ? _title : _html.title = "";
  if (titleByEntries) {
    extraConfig.html.title = ({ entryName }) => titleByEntries[entryName];
  }
  if (faviconByEntries) {
    extraConfig.html.favicon = ({ entryName }) => faviconByEntries[entryName];
  }
  if (injectByEntries) {
    extraConfig.html.inject = ({ entryName }) => injectByEntries[entryName];
  }
  if (templateByEntries) {
    extraConfig.html.template = ({ entryName }) => templateByEntries[entryName];
  }
  if (templateParametersByEntries) {
    extraConfig.html.templateParameters = (defaultValue, { entryName }) => ({
      ...defaultValue,
      ...templateParametersByEntries[entryName] || {}
    });
  }
  if (tags) {
    html.tags = Array.isArray(tags) ? tags.filter((t) => typeof t !== "function").concat(tags.filter((t) => typeof t === "function")) : tags;
  }
  if (tagsByEntries) {
    extraConfig.html.tags = [
      (tags2, utils) => {
        const entryTags = (0, import_shared.castArray)(tagsByEntries[utils.entryName]);
        const handlers = [];
        for (const tag of entryTags) {
          if ((0, import_shared.isFunction)(tag)) {
            handlers.push(tag);
          } else {
            tags2.push(tag);
          }
        }
        return handlers.reduce((currentTags, handler) => handler(currentTags, utils) || currentTags, tags2);
      }
    ];
  }
  var _tools;
  (_tools = (_extraConfig1 = extraConfig).tools) !== null && _tools !== void 0 ? _tools : _extraConfig1.tools = {};
  extraConfig.tools.htmlPlugin = (config) => {
    if (typeof config.templateParameters === "function") {
      const originFn = config.templateParameters;
      config.templateParameters = (...args) => {
        const res = originFn(...args);
        return {
          title: config.title,
          meta: void 0,
          ...res
        };
      };
    }
  };
  const { dev: RsbuildDev, server } = (0, import_devServer.transformToRsbuildServerOptions)(dev || {}, devServer || {});
  rsbuildConfig.server = removeUndefinedKey(server);
  rsbuildConfig.dev = removeUndefinedKey(RsbuildDev);
  rsbuildConfig.html = html;
  rsbuildConfig.output = output;
  if (entry) {
    var _rsbuildConfig;
    var _source;
    (_source = (_rsbuildConfig = rsbuildConfig).source) !== null && _source !== void 0 ? _source : _rsbuildConfig.source = {};
    rsbuildConfig.source.entry = entry;
  }
  const rsbuildPlugins = [
    (0, import_splitChunk.pluginSplitChunks)(),
    (0, import_globalVars.pluginGlobalVars)(globalVars),
    (0, import_devtools.pluginDevtool)({
      disableSourceMap
    }),
    (0, import_emitRouteFile.pluginEmitRouteFile)(),
    (0, import_plugin_toml.pluginToml)(),
    (0, import_plugin_yaml.pluginYaml)(),
    (0, import_antd.pluginAntd)(),
    (0, import_arco.pluginArco)()
  ];
  if (checkSyntax) {
    const { pluginCheckSyntax } = await Promise.resolve().then(() => __toESM(require("@rsbuild/plugin-check-syntax")));
    rsbuildPlugins.push(pluginCheckSyntax(typeof checkSyntax === "boolean" ? {} : checkSyntax));
  }
  if (!disableTsChecker) {
    const { pluginTypeCheck } = await Promise.resolve().then(() => __toESM(require("@rsbuild/plugin-type-check")));
    rsbuildPlugins.push(pluginTypeCheck({
      forkTsCheckerOptions: tsChecker
    }));
  }
  if (resolveMainFields) {
    const { pluginMainFields } = await Promise.resolve().then(() => __toESM(require("./plugins/mainFields")));
    rsbuildPlugins.push(pluginMainFields(resolveMainFields));
  }
  if (resolveExtensionPrefix) {
    const { pluginExtensionPrefix } = await Promise.resolve().then(() => __toESM(require("./plugins/extensionPrefix")));
    rsbuildPlugins.push(pluginExtensionPrefix(resolveExtensionPrefix));
  }
  if (convertToRem) {
    const { pluginRem } = await Promise.resolve().then(() => __toESM(require("@rsbuild/plugin-rem")));
    rsbuildPlugins.push(pluginRem(typeof convertToRem === "boolean" ? {} : convertToRem));
  }
  rsbuildPlugins.push((0, import_runtimeChunk.pluginRuntimeChunk)((_uniBuilderConfig_output = uniBuilderConfig.output) === null || _uniBuilderConfig_output === void 0 ? void 0 : _uniBuilderConfig_output.disableInlineRuntimeChunk));
  const { sourceBuild } = uniBuilderConfig.experiments || {};
  if (sourceBuild) {
    const { pluginSourceBuild } = await Promise.resolve().then(() => __toESM(require("@rsbuild/plugin-source-build")));
    rsbuildPlugins.push(pluginSourceBuild(sourceBuild === true ? {} : sourceBuild));
  }
  rsbuildPlugins.push((0, import_plugin_react.pluginReact)());
  if (!disableSvgr) {
    const { pluginSvgr } = await Promise.resolve().then(() => __toESM(require("@rsbuild/plugin-svgr")));
    rsbuildPlugins.push(pluginSvgr({
      mixedImport: true,
      svgrOptions: {
        exportType: svgDefaultExport === "component" ? "default" : "named"
      }
    }));
  }
  const pugOptions = (_uniBuilderConfig_tools = uniBuilderConfig.tools) === null || _uniBuilderConfig_tools === void 0 ? void 0 : _uniBuilderConfig_tools.pug;
  if (pugOptions) {
    const { pluginPug } = await Promise.resolve().then(() => __toESM(require("@rsbuild/plugin-pug")));
    rsbuildPlugins.push(pluginPug(typeof pugOptions === "boolean" ? {} : {
      pugOptions
    }));
  }
  if (assetsRetry) {
    const { pluginAssetsRetry } = await Promise.resolve().then(() => __toESM(require("@rsbuild/plugin-assets-retry")));
    rsbuildPlugins.push(pluginAssetsRetry(assetsRetry));
  }
  if (enableAssetFallback) {
    const { pluginFallback } = await Promise.resolve().then(() => __toESM(require("./plugins/fallback")));
    rsbuildPlugins.push(pluginFallback());
  }
  if (frameworkConfigPath) {
    rsbuildPlugins.push((0, import_frameworkConfig.pluginFrameworkConfig)(frameworkConfigPath));
  }
  rsbuildPlugins.push((0, import_plugin_css_minimizer.pluginCssMinimizer)({
    pluginOptions: minifyCss
  }));
  targets.includes("web") && rsbuildPlugins.push((0, import_postcssLegacy.pluginPostcssLegacy)(overrideBrowserslist.web));
  if (enableAssetManifest) {
    const { pluginManifest } = await Promise.resolve().then(() => __toESM(require("./plugins/manifest")));
    rsbuildPlugins.push(pluginManifest());
  }
  return {
    rsbuildConfig: (0, import_core.mergeRsbuildConfig)(rsbuildConfig, extraConfig),
    rsbuildPlugins
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  isLooseCssModules,
  parseCommonConfig
});
