"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var antd_exports = {};
__export(antd_exports, {
  pluginAntd: () => pluginAntd
});
module.exports = __toCommonJS(antd_exports);
var import_shared = require("@rsbuild/shared");
const getAntdMajorVersion = (appDirectory) => {
  try {
    const pkgJsonPath = require.resolve("antd/package.json", {
      paths: [
        appDirectory
      ]
    });
    const { version } = require(pkgJsonPath);
    return Number(version.split(".")[0]);
  } catch (err) {
    return null;
  }
};
const pluginAntd = () => ({
  name: "uni-builder:antd",
  setup(api) {
    api.modifyRsbuildConfig((rsbuildConfig) => {
      var _rsbuildConfig_source_transformImport;
      var _rsbuildConfig;
      var _source;
      (_source = (_rsbuildConfig = rsbuildConfig).source) !== null && _source !== void 0 ? _source : _rsbuildConfig.source = {};
      if (rsbuildConfig.source.transformImport === false || ((_rsbuildConfig_source_transformImport = rsbuildConfig.source.transformImport) === null || _rsbuildConfig_source_transformImport === void 0 ? void 0 : _rsbuildConfig_source_transformImport.some((item) => item.libraryName === "antd"))) {
        return;
      }
      const antdMajorVersion = getAntdMajorVersion(api.context.rootPath);
      if (antdMajorVersion && antdMajorVersion < 5) {
        var _rsbuildConfig1;
        var _source1;
        (_source1 = (_rsbuildConfig1 = rsbuildConfig).source) !== null && _source1 !== void 0 ? _source1 : _rsbuildConfig1.source = {};
        rsbuildConfig.source.transformImport = [
          ...rsbuildConfig.source.transformImport || [],
          {
            libraryName: "antd",
            libraryDirectory: (0, import_shared.isServerTarget)(api.context.targets) ? "lib" : "es",
            style: true
          }
        ];
      }
    });
  }
});
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  pluginAntd
});
