"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var postcssLegacy_exports = {};
__export(postcssLegacy_exports, {
  pluginPostcssLegacy: () => pluginPostcssLegacy
});
module.exports = __toCommonJS(postcssLegacy_exports);
var import_shared = require("@rsbuild/shared");
var import_getCssSupport = require("../getCssSupport");
const pluginPostcssLegacy = (webBrowserslist) => ({
  name: "uni-builder:postcss-plugins",
  setup(api) {
    api.modifyRsbuildConfig((config, { mergeRsbuildConfig }) => {
      const cssSupport = (0, import_getCssSupport.getCssSupport)(webBrowserslist);
      const enableExtractCSS = (0, import_shared.isUseCssExtract)(config, "web");
      const enableCssMinify = !enableExtractCSS && import_shared.isProd;
      const plugins = [
        require("postcss-flexbugs-fixes"),
        !cssSupport.customProperties && require("postcss-custom-properties"),
        !cssSupport.initial && require("postcss-initial"),
        !cssSupport.pageBreak && require("postcss-page-break"),
        !cssSupport.fontVariant && require("postcss-font-variant"),
        !cssSupport.mediaMinmax && require("postcss-media-minmax"),
        require("postcss-nesting"),
        enableCssMinify ? require("cssnano")({
          preset: [
            "default",
            {
              // merge longhand will break safe-area-inset-top, so disable it
              // https://github.com/cssnano/cssnano/issues/803
              // https://github.com/cssnano/cssnano/issues/967
              mergeLonghand: false
            }
          ]
        }) : false
      ].filter(Boolean);
      return mergeRsbuildConfig(
        {
          tools: {
            postcss: (opts) => {
              opts.postcssOptions.plugins.push(...plugins);
            }
          }
        },
        // user config has higher priority than builtin config
        config
      );
    });
  }
});
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  pluginPostcssLegacy
});
